<?php
// $Id$

/**
 * Theme links
 *
 * Add extra <span> to Primary links
 */
function scaccarium_links($links, $attributes = array('class' => 'links')) {
  global $language;
  $output = '';

  if (count($links) > 0) {
    $output = '<ul'. drupal_attributes($attributes) .'>';

    $num_links = count($links);
    $i = 1;

    foreach ($links as $key => $link) {
      $class = $key;

      // Add first, last and active classes to the list of links to help out themers.
      if ($i == 1) {
        $class .= ' first';
      }
      if ($i == $num_links) {
        $class .= ' last';
      }
      if (isset($link['href']) && ($link['href'] == $_GET['q'] || ($link['href'] == '<front>' && drupal_is_front_page()))
          && (empty($link['language']) || $link['language']->language == $language->language)) {
        $class .= ' active';
      }
      $output .= '<li'. drupal_attributes(array('class' => $class)) .'>';

      // Add extra <span> for Primary links
      if ($attributes['class'] == 'links primary-links') {
        $output .= '<span class="bg-image">';
      }

      if (isset($link['href'])) {
        // Pass in $link as $options, they share the same keys.
        $output .= l($link['title'], $link['href'], $link);
      }
      else if (!empty($link['title'])) {
        // Some links are actually not links, but we wrap these in <span> for adding title and class attributes
        if (empty($link['html'])) {
          $link['title'] = check_plain($link['title']);
        }
        $span_attributes = '';
        if (isset($link['attributes'])) {
          $span_attributes = drupal_attributes($link['attributes']);
        }
        $output .= '<span'. $span_attributes .'>'. $link['title'] .'</span>';
      }

      // Close extra <span> for Primary links
      if ($attributes['class'] == 'links primary-links') {
        $output .= '</span>';
      }

      $output .= '</li>';

      $i++;
      $output .= "\n";
    }

    $output .= '</ul>';
  }

  return $output;
}

/**
 * Theme breadcrumbs
 *
 * Change divider to '::'
 */
function scaccarium_breadcrumb($breadcrumb) {
  if (!empty($breadcrumb)) {
    return '<div class="breadcrumb">'. implode(' :: ', $breadcrumb) .'</div>';
  }
}

/**
 * Edit page variables
 *
 * Add additional class to <body> when content-top-region empty
 */
function scaccarium_preprocess_page(&$variables) {
  if (empty($variables['breadcrumb']) && empty($variables['mission']) && empty($variables['content_top']) && empty($variables['messages'])) {
    $variables['body_classes'] .= ' content-top-region-empty';
  }
}

/**
 * Theme tab links
 *
 * Add additional class to primary tabs when secondary tabs exist
 */
function scaccarium_menu_local_tasks() {
  $primary_output = '';
  $secondary_output = '';
  $primary_class = 'tabs primary';
  $secondary_class = 'tabs secondary';

  if ($secondary = menu_secondary_local_tasks()) {
    $primary_class .= ' has_secondary';
    $secondary_output .= "<ul class=\"". $secondary_class ."\">\n". $secondary ."</ul>\n";
  }

  if ($primary = menu_primary_local_tasks()) {
    $primary_output .= "<ul class=\"". $primary_class ."\">\n". $primary ."</ul>\n";
  }

  return $primary_output . $secondary_output;
}
